<?php if(!defined('DEDEINC')) exit('dedecms');

define('CHANGYAN_API_AES', 'http://www.dedecms.com/api/changyan/');
define('CHANGYAN_API_REG', 'http://changyan.sohu.com/admin/api/open/reg');
define('CHANGYAN_API_LOGIN', 'http://changyan.sohu.com/admin/api/open/validate');
define('CHANGYAN_API_SETCOOKIE', 'http://changyan.sohu.com/admin/api/open/set-cookie');
define('CHANGYAN_API_ISNEW', 'http://changyan.sohu.com/admin/api/recent-comment-topics');
define('CHANGYAN_API_LATESTS', 'http://changyan.sohu.com/api/2/comment/latests');
define('CHANGYAN_API_CODE', 'http://changyan.sohu.com/admin/api/open/get-code');
define('CHANGYAN_API_ADDSITE', 'http://changyan.sohu.com/admin/api/open/add-isv');
define('CHANGYAN_API_CHANGE_ISV', 'http://changyan.sohu.com/change-isv/');
define('CHANGYAN_API_CHECK_LOGIN', 'http://changyan.sohu.com/check-login');

define('CHANGYAN_CLIENT_ID', 'caqXYIe32');
define('CHANGYAN_CLIENT_KEY', 'bcb585628b59584891ff5897be888c45');

define('CHANGYAN_VER', '0.0.1');

function changyan_http_send($url, $limit=0, $post='', $cookie='', $timeout=15)
{
    $return = '';
    $matches = parse_url($url);
    $scheme = $matches['scheme'];
    $host = $matches['host'];
    $path = $matches['path'] ? $matches['path'].(@$matches['query'] ? '?'.$matches['query'] : '') : '/';
    $port = !empty($matches['port']) ? $matches['port'] : 80;

    if (function_exists('curl_init') && function_exists('curl_exec')) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $scheme.'://'.$host.':'.$port.$path);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        if ($post) {
            curl_setopt($ch, CURLOPT_POST, 1);
            $content = is_array($post) ? http_build_query($post) : $post;
            curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
        }
        if ($cookie) {
            curl_setopt($ch, CURLOPT_COOKIE, $cookie);
        }
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        $data = curl_exec($ch);
        $status = curl_getinfo($ch);
        $errno = curl_errno($ch);
        curl_close($ch);
        if ($errno || $status['http_code'] != 200) {
            return;
        } else {
            return !$limit ? $data : substr($data, 0, $limit);
        }
    }

    if ($post) {
        $content = is_array($port) ? http_build_query($post) : $post;
        $out = "POST $path HTTP/1.0\r\n";
        $header = "Accept: */*\r\n";
        $header .= "Accept-Language: zh-cn\r\n";
        $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
        $header .= "User-Agent: ".@$_SERVER['HTTP_USER_AGENT']."\r\n";
        $header .= "Host: $host:$port\r\n";
        $header .= 'Content-Length: '.strlen($content)."\r\n";
        $header .= "Connection: Close\r\n";
        $header .= "Cache-Control: no-cache\r\n";
        $header .= "Cookie: $cookie\r\n\r\n";
        $out .= $header.$content;
    } else {
        $out = "GET $path HTTP/1.0\r\n";
        $header = "Accept: */*\r\n";
        $header .= "Accept-Language: zh-cn\r\n";
        $header .= "User-Agent: ".@$_SERVER['HTTP_USER_AGENT']."\r\n";
        $header .= "Host: $host:$port\r\n";
        $header .= "Connection: Close\r\n";
        $header .= "Cookie: $cookie\r\n\r\n";
        $out .= $header;
    }

    $fpflag = 0;
    $fp = false;
    if (function_exists('fsocketopen')) {
        $fp = fsocketopen($host, $port, $errno, $errstr, $timeout);
    }
    if (!$fp) {
        $context = stream_context_create(array(
            'http' => array(
                'method' => $post ? 'POST' : 'GET',
                'header' => $header,
                'content' => $content,
                'timeout' => $timeout,
            ),
        ));
        $fp = @fopen($scheme.'://'.$host.':'.$port.$path, 'b', false, $context);
        $fpflag = 1;
    }

    if (!$fp) {
        return '';
    } else {
        stream_set_blocking($fp, true);
        stream_set_timeout($fp, $timeout);
        @fwrite($fp, $out);
        $status = stream_get_meta_data($fp);
        if (!$status['timed_out']) {
            while (!feof($fp) && !$fpflag) {
                if (($header = @fgets($fp)) && ($header == "\r\n" ||  $header == "\n")) {
                    break;
                }
            }
            if ($limit) {
                $return = stream_get_contents($fp, $limit);
            } else {
                $return = stream_get_contents($fp);
            }
        }
        @fclose($fp);
        return $return;
    }
}

function changyan_gen_sign($user)
{
	$aes_url=CHANGYAN_API_AES.'?key='.CHANGYAN_CLIENT_KEY.'&input='.$user;
	return changyan_http_send($aes_url);
}

function changyan_check_islogin()
{
	$jquery_url = CHANGYAN_API_AES."assets/js/jquery.min.js";
	$changyan_login=CHANGYAN_API_CHECK_LOGIN;
	echo <<<EOT
<script type="text/javascript" src="{$jquery_url}"></script>
<script type="text/javascript">
(function($){
	$.ajax({
	    type: "GET",
	    url: "{$changyan_login}",
		dataType : 'jsonp',
		jsonpCallback:"callfunc",
	    success: function(msg){
		    if(!msg.success){
				window.location.href='?dopost=logout&nomsg=yes';
			}
	    }
	});
})(jQuery)
</script>	
EOT;
	//exit;
}
/*
function str2Hex($string){
    $hex = '';
    for ($i=0; $i<strlen($string); $i++){
        $ord = ord($string[$i]);
        $hexCode = dechex($ord);
        $hex .= substr('0'.$hexCode, -2);
    }
    return strToUpper($hex);
}
function hex2Str($hex){
    $string='';
    for ($i=0; $i < strlen($hex)-1; $i+=2){
        $string .= chr(hexdec($hex[$i].$hex[$i+1]));
    }
    return $string;
}

function pkcs5_pad ($text) {
  $blocksize = mcrypt_get_block_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_ECB);
  $pad = $blocksize - (strlen($text) % $blocksize); 
  return $text . str_repeat(chr($pad), $pad); 
} 

function changyan_gen_sign2($user)
{
	$now_time = round(microtime(true), 3) * 1000;
	$key = hex2Str(CHANGYAN_CLIENT_KEY);
	$encrypted = mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, pkcs5_pad($user.'_'.$now_time), MCRYPT_MODE_ECB);
	return str2Hex($encrypted);
}
*/

function changyan_latests($client_id,$pagesize=20,$order='hot')
{
	$latests_url=CHANGYAN_API_LATESTS."/?client_id={$client_id}&size={$pagesize}&order_by={$order}";
	return json_decode(changyan_http_send($latests_url),TRUE);
}

function changyan_getcode($client_id, $user, $is_mobile, $sign)
{
	$getcode_url=CHANGYAN_API_CODE."/?client_id={$client_id}&user={$user}&is_mobile={$is_mobile}&sign={$sign}";
	return json_decode(changyan_http_send($getcode_url),TRUE);
}

function changyan_islogin()
{
	return empty($_SESSION['changyan'])? FALSE : TRUE;
}

function changyan_get_setting($skey, $time=false, $real=false)
{
    global $dsql;
    static $setting = array();
    $skey=addslashes($skey);
    if (empty($setting[$skey]) || $real) {
        $row = $dsql->GetOne("SELECT * FROM `#@__plus_changyan_setting` WHERE skey='{$skey}'");
        $setting[$skey]['svalue']=$row['svalue'];
        $setting[$skey]['stime']=$row['stime'];
    }
    if (!isset($setting[$skey])) return $time ? array() : null;
    return $time ? $setting[$skey] : $setting[$skey]['svalue'];
}

function changyan_set_setting($skey, $svalue)
{
    global $dsql;
    $stime=time();
    $skey=addslashes($skey);
    $svalue=addslashes($svalue);
    $sql="UPDATE `#@__plus_changyan_setting` SET svalue='{$svalue}',stime='{$stime}' WHERE skey='{$skey}' ";
    $dsql->ExecuteNoneQuery($sql);
}

function changyan_addsite($user, $isv_name, $url)
{
	$sign=changyan_gen_sign($user);
	$paramsArr=array(
		'client_id'=>CHANGYAN_CLIENT_ID, 
		'user'=>$user, 
		'isv_name'=>$isv_name,
		'url'=>$url,
		'sign'=>$sign);
	$rs=changyan_http_send(CHANGYAN_API_ADDSITE,0,$paramsArr);
	return json_decode($rs, TRUE);
}

?>