<?php
//@session_start();
require_once(dirname(__FILE__)."/config.php");
require_once(DEDEINC."/oxwindow.class.php");

helper('changyan');

if(empty($dopost)) $dopost = '';
if(empty($action)) $action = '';

$_SESSION['changyan'] = isset($_SESSION['changyan'])? $_SESSION['changyan'] : 0;
$_SESSION['user'] = isset($_SESSION['user'])? $_SESSION['user'] : '';

$client_id=changyan_get_setting('appid');
if($dopost=='reg')
{
    $msg = <<<EOT
<table width="98%" border="0" cellspacing="1" cellpadding="1">
  <tbody>
    <tr>
      <td height="30" colspan="2" style="color:#999"><strong>畅言</strong>是一个简单而强大的社会化评论及聚合平台。用户可以直接用自己的社会化网络账户在第三方网站发表评论，并且一键评论同步至社交网络将网站内容和自己的评论分享给好友。增加第三方网站用户活跃度，调动好友参与评论，帮助网站实现社会化网络优化，有效提升网站社会化流量！</td>
    </tr>
    <tr>
      <td height="30" colspan="2" style="color:#999"></td>
    </tr>
    <tr>
      <td width="16%" height="30">邮箱：</td>
      <td width="84%" style="text-align:left;"><input name="user" type="text" id="user" size="16" style="width:200px" /></td>
    </tr>
    <tr>
      <td height="30">密码：</td>
      <td style="text-align:left;"><input name="pwd" type="password" id="pwd" size="16" style="width:200px">
        &nbsp;（留能用'0-9a-zA-Z.@_-!'以内范围的字符） </td>
    </tr>
    <tr>
      <td height="30">确认密码：</td>
      <td style="text-align:left;"><input name="repwd" type="password" id="repwd" size="16" style="width:200px">
        &nbsp;</td>
    </tr>
    <tr>
      <td width="16%" height="30">网站名称：</td>
      <td width="84%" style="text-align:left;"><input name="isv_name" type="hidden" id="isv_name" size="16" style="width:200px" value="{$cfg_webname}" />{$cfg_webname}</td>
    </tr>
    <tr>
      <td width="16%" height="30">网站地址：</td>
      <td width="84%" style="text-align:left;"><input name="url" type="hidden" id="url" size="16" style="width:200px"  value="{$cfg_basehost}" />{$cfg_basehost}</td>
    </tr>
  </tbody>
</table>
EOT;

    $wintitle = '注册畅言帐号：';
    $wecome_info = '<a href="?">畅言评论插件</a> 》注册帐号';
    $win = new OxWindow();
	$win->Init('?','js/blank.js','POST');
	$win->AddHidden('dopost','doreg');
    $win->AddTitle($wintitle);
    $win->AddMsgItem($msg);
    $winform = $win->GetWindow('ok', '&nbsp;', false);
    $win->Display();

} elseif ($dopost=='doreg') {
	$user = empty($user)? '' : $user;
	$pwd = empty($pwd)? '' : $pwd;
	$repwd = empty($repwd)? '' : $repwd;
	$isv_name = empty($isv_name)? '' : $isv_name;
	$url = empty($url)? '' : $url;
	if(empty($isv_name) OR empty($url))
	{
        ShowMsg("您需要填写正确的站点信息，请重新填写",-1);
        exit();
	}
	if(empty($user) OR empty($pwd) OR empty($repwd))
	{
        ShowMsg("您需要填写E-mail和密码，请重新填写",-1);
        exit();
	}
	if(!CheckEmail($user))
	{
        ShowMsg("您的E-mail格式错误，请重新填写",-1);
        exit();
	}
	if($pwd != $repwd)
	{
        ShowMsg("填写两次密码不同，请返回重新输入！",-1);
        exit();
	}
	$sign=changyan_gen_sign($user);
	$paramsArr=array(
		'client_id'=>CHANGYAN_CLIENT_ID, 
		'user'=>$user, 
		'password'=>$pwd, 
		'isv_name'=>$isv_name, 
		'url'=>$url, 
		'sign'=>$sign);
	$rs=changyan_http_send(CHANGYAN_API_REG,0,$paramsArr);
	$result=json_decode($rs,TRUE);
	$errorinfo['appid not exist']='client_id不存在';
	$errorinfo['sign error']='签名验证失败';
	$errorinfo['user name exist']='注册用户已经存在';
	if($result['status']==0)
	{
		// 保存appid,id信息
		changyan_set_setting('user', $user);
		changyan_set_setting('appid', $result['appid']);
		changyan_set_setting('id', $result['id']);
		changyan_set_setting('isv_id', $result['isv_id']);
        ShowMsg("您已经成功注册，现在进行登录！",'?');
        exit();
	} else {
        ShowMsg("无法正常注册，错误信息：".$errorinfo[$result['msg']], -1);
        exit();
	}
} elseif ($dopost=='login') {
	$user = empty($user)? '' : $user;
	$pwd = empty($pwd)? '' : $pwd;
	$rmpwd = empty($rmpwd)? '' : $rmpwd;
	if(empty($user) OR empty($pwd))
	{
        ShowMsg("您需要填写E-mail和密码，请重新填写",-1);
        exit();
	}
	if(!CheckEmail($user))
	{
        ShowMsg("您的E-mail格式错误，请重新填写",-1);
        exit();
	}
	$sign=changyan_gen_sign($user);
	$paramsArr=array(
		'client_id'=>CHANGYAN_CLIENT_ID, 
		'user'=>$user, 
		'password'=>$pwd, 
		'sign'=>$sign);
	$rs=changyan_http_send(CHANGYAN_API_LOGIN,0,$paramsArr);
	$result=json_decode($rs,TRUE);
	if($result['status']==1)
	{
        ShowMsg("无法登录，请检查您的帐号信息是否填写正确！",-1);
        exit();
	} elseif ($result['status']==0)
	{
	    $_SESSION['changyan']=$result['token'];
		$_SESSION['user']=$user;
		$isv_id = changyan_get_setting('isv_id');
		if(empty($isv_id))
		{
			// 还没有安装则添加当前站点
			$result=changyan_addsite($user, $cfg_webname, $cfg_basehost);
			$isv_id = $result['isv_id'];
			changyan_set_setting('user', $user);
			changyan_set_setting('appid', $result['appid']);
			changyan_set_setting('id', $result['id']);
			changyan_set_setting('isv_id', $result['isv_id']);
		}
		$login_url=CHANGYAN_API_SETCOOKIE.'?client_id='.CHANGYAN_CLIENT_ID.'&token='.$result['token'];
		
		echo <<<EOT
<iframe src="{$login_url}" scrolling="no" width="0" height="0" style="border:none"></iframe>
EOT;
        ShowMsg("成功登录畅言，进行站点切换……",'?dopost=changeisv&isv_id='.$isv_id);
        exit();
	} else {
        ShowMsg("无法登录，未知错误！",-1);
        exit();
	}
} elseif ($dopost=='changeisv') {
	$isv_id = intval($isv_id);
	$changge_isv_url = CHANGYAN_API_CHANGE_ISV.$isv_id;
	echo <<<EOT
<iframe src="{$changge_isv_url}" scrolling="no" width="0" height="0" style="border:none"></iframe>
EOT;
	ShowMsg("成功切换站点！",'?');
	exit();
} elseif ($dopost=='isnew') {
	$rs=changyan_http_send(CHANGYAN_API_ISNEW.'/?appId='.$client_id.'&date='.urlencode( date('Y-m-d h:i:s')));
	$result=json_decode($rs,TRUE);
	if(count($result['topics'])>0) exit('true');
	else exit('false');
} elseif ($dopost=='latests') {
	$latests = changyan_latests($client_id);
	$data = array();
	if(count($latests['comments']) > 0)
	{
		foreach($latests['comments'] as $k => $v)
		{
			$data[] = array(
				'nickname'=>$v['passport']['nickname'],
				'content'=>$v['content'],
				'topic_title'=>$v['topic_title'],
				'topic_url'=>$v['topic_url'],
			);
		}
	}
	echo json_encode($latests);
	exit;
} elseif ($dopost=='getcode') {
	if(!changyan_islogin())
	{
        ShowMsg("您尚未登录畅言，请先登录后继续使用……！",'?');
        exit();
	}
	changyan_check_islogin();
	$user=changyan_get_setting('user');
	$sign=changyan_gen_sign($user);
	$result = changyan_getcode(CHANGYAN_CLIENT_ID, $user, false, $sign);
	$code = htmlspecialchars($result['code']);
    $msg = <<<EOT
<style type='text/css'>
pre {
width:50%;
display: block;
padding: 9.5px;
margin: 0 0 10px;
font-size: 13px;
line-height: 20px;
word-break: break-all;
word-wrap: break-word;
white-space: pre;
white-space: pre-wrap;
background-color: #f5f5f5;
border: 1px solid #ccc;
border: 1px solid rgba(0,0,0,0.15);
-webkit-border-radius: 4px;
-moz-border-radius: 4px;
border-radius: 4px;
}
</style>
<p>DedeCMS标签代码（将代码插入到模板页面对应位置即可）：</p>
<pre id="iframe" style="height:50px;">   
{dede:changyan/}     
</pre>
<p>Javascript代码（将代码插入到模板页面对应位置即可）：</p>
<pre id="iframe" style="height:150px;">   
{$code}         
</pre>
EOT;

    $wintitle = '畅言评论管理';
    $wecome_info = '<a href="?">畅言评论插件</a> 》获取代码';
    $win = new OxWindow();
    $win->AddTitle($wintitle);
    $win->AddMsgItem($msg);
    $winform = $win->GetWindow('hand', '&nbsp;', false);
    $win->Display();
	
} elseif ($dopost=='addsite') {
	exit('error!');
	$sign=changyan_gen_sign($user);
	$paramsArr=array(
		'client_id'=>CHANGYAN_CLIENT_ID, 
		'user'=>$user, 
		'isv_name'=>'dedecms_com',
		'url'=>'www.dedecms.com',
		'sign'=>$sign);
	$rs=changyan_http_send(CHANGYAN_API_ADDSITE,0,$paramsArr);
} elseif ($dopost=='manage' OR $dopost=='stat' OR $dopost=='setting'
OR $dopost=="import")
{
	if(!changyan_islogin())
	{
        ShowMsg("您尚未登录畅言，请先登录后继续使用……！",'?');
        exit();
	}
	changyan_check_islogin();
	$addstyle='scrolling="no" ';
	$type='audit';
	$appid=changyan_get_setting('appid');
	if($dopost=='manage') $type='audit';
	elseif($dopost=='stat') $type='stat';
	$ptitle = '畅言评论管理';

	$manage_url="http://changyan.sohu.com/audit/comments/TOAUDIT/1";
	if($dopost=='setting') 
	{
		$ptitle = "畅言设置";
		$manage_url="http://changyan.sohu.com/setting/basic";
		
	} elseif ($dopost=='stat')
	{
		$ptitle = "数据统计";
		$manage_url="http://changyan.sohu.com/stat-data/comment";
	} elseif ($dopost=='import')
	{
		$ptitle = "畅言工具";
		$manage_url="http://changyan.sohu.com/cmt-util/import";
		
	}
	$addstyle='scrolling="auto" ';
	echo <<<EOT
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset={$cfg_soft_lang}">
<title>{$ptitle}</title>
<link rel="stylesheet" type="text/css" href="css/base.css">
</head>
<body background='images/allbg.gif' leftmargin="8" topmargin='8'>
<table width="98%" border="0" align="center" cellpadding="0" cellspacing="0" bgcolor="#DFF9AA" height="100%">
  <tr>
    <td height="28" style="border:1px solid #DADADA" background='images/wbg.gif'>
	
	<div style="float:left">&nbsp;<b>◇<a href="?">畅言评论插件</a> 》{$ptitle}</b></div>
	<div style="float:right;margin-right:20px;">您好：{$_SESSION['user']} <a href="?dopost=logout">退出</a></div>
	</td>
  </tr>
  <tr>
    <td width="100%" height="100%" valign="top" bgcolor='#ffffff' style="padding-top:5px"><table width='100%'  border='0' cellpadding='3' cellspacing='1' bgcolor='#DADADA' height="100%">
        <tr bgcolor='#DADADA'>
          <td colspan='2' background='images/wbg.gif' height='26'><font color='#666600'><b>{$ptitle}</b></font></td>
        </tr>
        <tr bgcolor='#FFFFFF'>
          <td colspan='2' height='100%' style='padding:20px'><br/><iframe src="{$manage_url}" {$addstyle} width="100%" height="100%" style="border:none"></iframe></td>
        </tr>
        <tr>
          <td bgcolor='#F5F5F5'>&nbsp;</td>
        </tr>
      </table></td>
  </tr>
</table>
<p align="center"> <br>
  <br>
</p>
</body>
</html>

EOT;
} elseif ($dopost=='checkupdate')
{
    $get_latest_ver = changyan_http_send(CHANGYAN_API_AES.'index.php?c=welcome&m=get_latest_ver');
    if(version_compare($get_latest_ver, CHANGYAN_VER,'>'))
    {
        ShowMsg("检查到有最新版本，请前去下载！<br /><a href='http://bbs.dedecms.com/650203.html' target='_blank' style='color:blue'>点击前去下载</a> <a href='?' >返回</a>","javascript:;");
        exit();
    } else {
        ShowMsg("当前为最新版本，无须下载更新！","javascript:;");
        exit();
    }
	exit();
} elseif ($dopost=='logout')
{
	echo <<<EOT
<iframe src="http://changyan.sohu.com/logout" scrolling="no" width="0" height="0"></iframe>
EOT;
	$_SESSION['changyan'] = 0;
	$_SESSION['user'] = '';
	if($nomsg)
	{
		header('Location:?');
		exit;
	}
	ShowMsg("成功退出畅言！",'?');
	exit();
} else {
	$user = changyan_get_setting('user');
	$user = empty($user)? '' : ' value="'.$user.'"';
    $msg = <<<EOT
<table width="98%" border="0" cellspacing="1" cellpadding="1">
  <tbody>
    <tr>
      <td width="16%" height="30">邮箱：</td>
      <td width="84%" style="text-align:left;"><input name="user" type="text" id="user" size="16" style="width:200px"{$user} />
        <a href="?dopost=reg" >没有账号？去注册……</a></td>
    </tr>
    <tr>
      <td height="30">密码：</td>
      <td style="text-align:left;"><input name="pwd" type="password" id="pwd" size="16" style="width:200px">
        &nbsp;（留能用'0-9a-zA-Z.@_-!'以内范围的字符） </td>
    </tr>
    <!--<tr>
      <td height="30">记住密码：</td>
      <td style="text-align:left;"><input type="checkbox" name="rmpwd" id="rmpwd" />
        <label for="rmpwd">下次登录不用再输入（不推荐）</label></td>
    </tr>-->
  </tbody>
</table>
EOT;
	if(changyan_islogin())
	{
		$changyan_ver = CHANGYAN_VER;
		$msg = <<<EOT
<table width="98%" border="0" cellspacing="1" cellpadding="1">
  <tbody>
    <tr>
      <td width="16%" height="30">登录用户：</td>
      <td width="84%" style="text-align:left;">{$_SESSION['user']}</td>
    </tr>
    <tr>
      <td width="16%" height="30">畅言模块版本：</td>
      <td width="84%" style="text-align:left;">v{$changyan_ver} <a href='?dopost=checkupdate' style='color:blue'>[检查更新]</a> </td>
    </tr>
    <tr>
      <td height="30" colspan="2">您已成功登录畅言！您可以进行以下操作：</td>
    </tr>
    <tr>
      <td height="30" colspan="2">
	  <a href='?dopost=manage' style='color:blue'>[评论管理]</a> 
	  <a href='?dopost=stat' style='color:blue'>[数据统计]</a> 
	  <a href='?dopost=import' style='color:blue'>[导入导出]</a> 
	  <a href='?dopost=setting' style='color:blue'>[畅言设置]</a> 
	  <a href='?dopost=logout' style='color:blue'>[退出]</a></td>
    </tr>
<tr>
      <td height="30" colspan="2">
   <hr>
   使用说明：<br>
   在对应模板中使用标签：<font color="red">{dede:changyan/}</font>，直接进行调用即可，样式设定可点击<a href='?dopost=setting' style='color:blue'>[畅言设置]</a> 进行设置。
  <hr>
  功能说明：<br>
  <b>[评论管理]</b>审核、删除评论信息，敏感词管理，用户禁言操作；<br>
 <b>[数据统计]</b>站点评论信息数据全方位统计；<br>
 <b>[导入导出]</b>评论信息数据导入/导出，建议用户定期导出备份；<br>
 <b>[畅言设置]</b>畅言评论相关设定；<br><br>
<hr>
    </tr>
    <tr>
      <td height="30" colspan="2" style="color:#999"><strong>畅言</strong>是一个简单而强大的社会化评论及聚合平台。用户可以直接用自己的社会化网络账户在第三方网站发表评论，并且一键评论同步至社交网络将网站内容和自己的评论分享给好友。增加第三方网站用户活跃度，调动好友参与评论，帮助网站实现社会化网络优化，有效提升网站社会化流量！</td>
    </tr>
  </tbody>
</table>
EOT;
		$wintitle = '畅言评论管理';
		$wecome_info = '畅言评论插件 》';
		$win = new OxWindow();
		$win->AddTitle($wintitle);
		$win->AddMsgItem($msg);
		$winform = $win->GetWindow('hand', '&nbsp;', false);
		$win->Display();
	} else {
		$wintitle = '畅言评论管理';
		$wecome_info = '畅言评论插件 》';
		$win = new OxWindow();
		$win->Init('?','js/blank.js','POST');
		$win->AddHidden('dopost','login');
		$win->AddTitle($wintitle);
		$win->AddMsgItem($msg);
		$winform = $win->GetWindow('ok', '&nbsp;', false);
		$win->Display();
	}
}
?>